﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

/*
# This file is part of the PiXtend(R) Project.
#
# For more information about PiXtend(R) and this program,
# see <https://www.pixtend.de> or <https://www.pixtend.com>
#
# Copyright (C) 2019 Robin Turner
# Qube Solutions GmbH, Arbachtalstr. 6
# 72800 Eningen, Germany
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

namespace PiXtend_eIO_Demo
{
    public partial class PropertiesDlg : Form
    {
        private int _num;
        private string _device_type;
        private int _device_id;
        private string _data_type;
        private int _value;

        public PropertiesDlg()
        {
            InitializeComponent();
        }

        public int ListNumber
        {
            get { return _num; }
            set { _num = value; }
        }

        public string DeviceType
        {
            get { return _device_type; }
            set { _device_type = value; }
        }

        public int DeviceID
        {
            get { return _device_id; }
            set { _device_id = value; }
        }

        public string DataType
        {
            get { return _data_type; }
            set { _data_type = value; }
        }

        public int Value
        {
            get { return _value; }
            set { _value = value; }
        }

        private void cmdOK_Click(object sender, EventArgs e)
        {
            this.DeviceType = cbDeviceType.SelectedItem.ToString();
            this.DeviceID = (int)nudDeviceID.Value;
            this.DataType = cbDataType.SelectedItem.ToString();
            this.Value = (int)nudValue.Value;

            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void PropertiesDlg_Shown(object sender, EventArgs e)
        {
            cbDeviceType.Text = _device_type;
            lblDeviceNumber.Text = _num.ToString();
            nudDeviceID.Value = (decimal)_device_id;
            cbDataType.Text = _data_type;
            nudValue.Value = (decimal)_value;
        }

        private void cbDeviceType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbDeviceType.Text == "Analog One")
            {
                if (cbDataType.Text.Contains("DO") || cbDataType.Text.Contains("DI"))
                {
                    cbDataType.Text = "AI 0";
                }
            }
            if (cbDeviceType.Text == "Digital One")
            {
                if (cbDataType.Text.Contains("AI") || cbDataType.Text.Contains("AO"))
                {
                    cbDataType.Text = "DI 0";
                }
            }
        }

        private void cbDataType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbDeviceType.Text == "Analog One")
            {
                if (cbDataType.Text.Contains("AO"))
                {
                    nudValue.Enabled = true;
                    nudValue.Maximum = 4095;
                }
                else
                {
                    nudValue.Enabled = false;
                    nudValue.Value = 0;
                }
                if (cbDataType.Text.Contains("DO") || cbDataType.Text.Contains("DI"))
                {
                    cbDeviceType.Text = "Digital One";

                    if (cbDataType.Text.Contains("DO"))
                    {
                        nudValue.Maximum = 1;
                        nudValue.Enabled = true;
                    }
                    else
                    {
                        nudValue.Enabled = false;
                        nudValue.Value = 0;
                    }
                }
            }
            if (cbDeviceType.Text == "Digital One")
            {
                if (cbDataType.Text.Contains("DO"))
                {
                    nudValue.Maximum = 1;
                    nudValue.Enabled = true;
                }
                else
                {
                    nudValue.Enabled = false;
                    nudValue.Value = 0;
                }
                if (cbDataType.Text.Contains("AI") || cbDataType.Text.Contains("AO"))
                {
                    cbDeviceType.Text = "Analog One";

                    if (cbDataType.Text.Contains("AO"))
                    {
                        nudValue.Enabled = true;
                        nudValue.Maximum = 4095;
                    }
                    else
                    {
                        nudValue.Enabled = false;
                        nudValue.Value = 0;
                    }
                }
            }
        }
    }
}
