﻿# This file is part of the PiXtend(R) Project.
#
# For more information about PiXtend(R) and this program,
# see <https://www.pixtend.de> or <https://www.pixtend.com>
#
# Copyright (C) 2019 Robin Turner
# Qube Solutions GmbH, Arbachtalstr. 6
# 72800 Eningen, Germany
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import System.Drawing
import System.Windows.Forms
import time

from System.Drawing import *
from System.Windows.Forms import *
from System import *

class MainForm(Form):
    def __init__(self):
        self.InitializeComponent()
    
    def InitializeComponent(self):
        self._cbCommand = System.Windows.Forms.ComboBox()
        self._menuStrip1 = System.Windows.Forms.MenuStrip()
        self._fileToolStripMenuItem = System.Windows.Forms.ToolStripMenuItem()
        self._exitToolStripMenuItem = System.Windows.Forms.ToolStripMenuItem()
        self._txtFullCommand = System.Windows.Forms.TextBox()
        self._label1 = System.Windows.Forms.Label()
        self._label2 = System.Windows.Forms.Label()
        self._cmdSend = System.Windows.Forms.Button()
        self._txtResponse = System.Windows.Forms.TextBox()
        self._label3 = System.Windows.Forms.Label()
        self._label4 = System.Windows.Forms.Label()
        self._txtAddress = System.Windows.Forms.TextBox()
        self._label5 = System.Windows.Forms.Label()
        self._txtIoNum = System.Windows.Forms.TextBox()
        self._label6 = System.Windows.Forms.Label()
        self._txtValue = System.Windows.Forms.TextBox()
        self._label7 = System.Windows.Forms.Label()
        self._menuStrip1.SuspendLayout()
        self.SuspendLayout()
        # 
        # cbCommand
        # 
        self._cbCommand.FormattingEnabled = True
        self._cbCommand.Items.AddRange(System.Array[System.Object](
            ["Read Analog Input",
            "Write Analog Output",
            "Read Digital Input",
            "Write Digital Output",
            "Read Status Digital"]))
        self._cbCommand.Location = System.Drawing.Point(109, 60)
        self._cbCommand.Name = "cbCommand"
        self._cbCommand.Size = System.Drawing.Size(123, 21)
        self._cbCommand.TabIndex = 0
        self._cbCommand.Text = "Read Digital Input"
        self._cbCommand.SelectedIndexChanged += self.CbCommandSelectedIndexChanged
        # 
        # menuStrip1
        # 
        self._menuStrip1.Items.AddRange(System.Array[System.Windows.Forms.ToolStripItem](
            [self._fileToolStripMenuItem]))
        self._menuStrip1.Location = System.Drawing.Point(0, 0)
        self._menuStrip1.Name = "menuStrip1"
        self._menuStrip1.Size = System.Drawing.Size(408, 24)
        self._menuStrip1.TabIndex = 1
        self._menuStrip1.Text = "menuStrip1"
        # 
        # fileToolStripMenuItem
        # 
        self._fileToolStripMenuItem.DropDownItems.AddRange(System.Array[System.Windows.Forms.ToolStripItem](
            [self._exitToolStripMenuItem]))
        self._fileToolStripMenuItem.Name = "fileToolStripMenuItem"
        self._fileToolStripMenuItem.Size = System.Drawing.Size(37, 20)
        self._fileToolStripMenuItem.Text = "&File"
        # 
        # exitToolStripMenuItem
        # 
        self._exitToolStripMenuItem.Name = "exitToolStripMenuItem"
        self._exitToolStripMenuItem.Size = System.Drawing.Size(92, 22)
        self._exitToolStripMenuItem.Text = "E&xit"
        self._exitToolStripMenuItem.Click += self.ExitToolStripMenuItemClick
        # 
        # txtFullCommand
        # 
        self._txtFullCommand.Location = System.Drawing.Point(35, 120)
        self._txtFullCommand.Name = "txtFullCommand"
        self._txtFullCommand.Size = System.Drawing.Size(234, 20)
        self._txtFullCommand.TabIndex = 2
        # 
        # label1
        # 
        self._label1.Location = System.Drawing.Point(109, 42)
        self._label1.Name = "label1"
        self._label1.Size = System.Drawing.Size(100, 15)
        self._label1.TabIndex = 3
        self._label1.Text = "Command:"
        # 
        # label2
        # 
        self._label2.Location = System.Drawing.Point(35, 99)
        self._label2.Name = "label2"
        self._label2.Size = System.Drawing.Size(100, 18)
        self._label2.TabIndex = 4
        self._label2.Text = "Command as Text:"
        # 
        # cmdSend
        # 
        self._cmdSend.Location = System.Drawing.Point(282, 120)
        self._cmdSend.Name = "cmdSend"
        self._cmdSend.Size = System.Drawing.Size(75, 20)
        self._cmdSend.TabIndex = 5
        self._cmdSend.Text = "Send"
        self._cmdSend.UseVisualStyleBackColor = True
        self._cmdSend.Click += self.CmdSendClick
        # 
        # txtResponse
        # 
        self._txtResponse.Enabled = False
        self._txtResponse.Location = System.Drawing.Point(35, 171)
        self._txtResponse.Name = "txtResponse"
        self._txtResponse.Size = System.Drawing.Size(231, 20)
        self._txtResponse.TabIndex = 6
        # 
        # label3
        # 
        self._label3.Location = System.Drawing.Point(35, 153)
        self._label3.Name = "label3"
        self._label3.Size = System.Drawing.Size(100, 15)
        self._label3.TabIndex = 7
        self._label3.Text = "Response:"
        # 
        # label4
        # 
        self._label4.Location = System.Drawing.Point(35, 42)
        self._label4.Name = "label4"
        self._label4.Size = System.Drawing.Size(51, 13)
        self._label4.TabIndex = 8
        self._label4.Text = "Address:"
        # 
        # txtAddress
        # 
        self._txtAddress.Location = System.Drawing.Point(35, 61)
        self._txtAddress.Name = "txtAddress"
        self._txtAddress.Size = System.Drawing.Size(68, 20)
        self._txtAddress.TabIndex = 9
        self._txtAddress.Text = "1"
        self._txtAddress.TextChanged += self.TxtAddressTextChanged
        # 
        # label5
        # 
        self._label5.Location = System.Drawing.Point(243, 42)
        self._label5.Name = "label5"
        self._label5.Size = System.Drawing.Size(61, 15)
        self._label5.TabIndex = 10
        self._label5.Text = "IO Number:"
        # 
        # txtIoNum
        # 
        self._txtIoNum.Location = System.Drawing.Point(243, 61)
        self._txtIoNum.Name = "txtIoNum"
        self._txtIoNum.Size = System.Drawing.Size(61, 20)
        self._txtIoNum.TabIndex = 11
        self._txtIoNum.Text = "0"
        self._txtIoNum.TextChanged += self.TxtIoNumTextChanged
        # 
        # label6
        # 
        self._label6.Location = System.Drawing.Point(320, 42)
        self._label6.Name = "label6"
        self._label6.Size = System.Drawing.Size(61, 15)
        self._label6.TabIndex = 12
        self._label6.Text = "Value:"
        # 
        # txtValue
        # 
        self._txtValue.Location = System.Drawing.Point(320, 61)
        self._txtValue.Name = "txtValue"
        self._txtValue.Size = System.Drawing.Size(61, 20)
        self._txtValue.TabIndex = 13
        self._txtValue.Text = "0"
        self._txtValue.TextChanged += self.TxtValueTextChanged
        # 
        # label7
        # 
        self._label7.Location = System.Drawing.Point(40, 213)
        self._label7.Name = "label7"
        self._label7.Size = System.Drawing.Size(317, 36)
        self._label7.TabIndex = 14
        self._label7.Text = "Hint: Adapt the com port setting in the source code to an existing serial adapter with RS485 capabilities."
        # 
        # MainForm
        # 
        self.ClientSize = System.Drawing.Size(408, 258)
        self.Controls.Add(self._label7)
        self.Controls.Add(self._txtValue)
        self.Controls.Add(self._label6)
        self.Controls.Add(self._txtIoNum)
        self.Controls.Add(self._label5)
        self.Controls.Add(self._txtAddress)
        self.Controls.Add(self._label4)
        self.Controls.Add(self._label3)
        self.Controls.Add(self._txtResponse)
        self.Controls.Add(self._cmdSend)
        self.Controls.Add(self._label2)
        self.Controls.Add(self._label1)
        self.Controls.Add(self._txtFullCommand)
        self.Controls.Add(self._cbCommand)
        self.Controls.Add(self._menuStrip1)
        self.DoubleBuffered = True
        self.MainMenuStrip = self._menuStrip1
        self.MaximizeBox = False
        self.Name = "MainForm"
        self.Text = "PiXtend eIO Demo"
        self.Shown += self.MainFormShown
        self._menuStrip1.ResumeLayout(False)
        self._menuStrip1.PerformLayout()
        self.ResumeLayout(False)
        self.PerformLayout()

    def BuildCommand(self):
        #Start marker for PiXtend eIO Protocol
        sTempCmd = "#"
        iValueLen = 0
        #Add Device Address
        if (len(self._txtAddress.Text) == 1):
            sTempCmd = sTempCmd + "00"       
        if (len(self._txtAddress.Text) == 2):
            sTempCmd = sTempCmd + "0" 
        sTempCmd = sTempCmd + self._txtAddress.Text
        #Add Devider
        sTempCmd = sTempCmd + ":"
        #Determine Command for the device
        if (self._cbCommand.Text == "Read Analog Input"):
            sTempCmd = sTempCmd + "005"
            iValueLen = 4
        if (self._cbCommand.Text == "Write Analog Output"):
            sTempCmd = sTempCmd + "006"
            iValueLen = 4
        if (self._cbCommand.Text == "Read Digital Input"):
            sTempCmd = sTempCmd + "001"
            iValueLen = 3            
        if (self._cbCommand.Text == "Write Digital Output"):
            sTempCmd = sTempCmd + "003"
            iValueLen = 3
        if (self._cbCommand.Text == "Read Status Digital"):
            sTempCmd = sTempCmd + "200"
            iValueLen = 3
        #Add Devider
        sTempCmd = sTempCmd + ":"
        #Add the number of the IO to read from to write to
        if (len(self._txtIoNum.Text) == 1):
            sTempCmd = sTempCmd + "0"   
            
        sTempCmd = sTempCmd + self._txtIoNum.Text
        #Add Devider
        sTempCmd = sTempCmd + ":"
        #Add desired value for Write Commands,
        #for Read Commands this will be ignored by the module
        #but is needed to build a complete message
        if (iValueLen == 4):
            if (len(self._txtValue.Text) == 1):
                sTempCmd = sTempCmd + "000"
            if (len(self._txtValue.Text) == 2):
                sTempCmd = sTempCmd + "00"
            if (len(self._txtValue.Text) == 3):
                sTempCmd = sTempCmd + "0"
        if (iValueLen == 3):
            if (len(self._txtValue.Text) == 1):
                sTempCmd = sTempCmd + "00"
            if (len(self._txtValue.Text) == 2):
                sTempCmd = sTempCmd + "0"                
        
        sTempCmd = sTempCmd + self._txtValue.Text
        #End signal of the protocol/message
        sTempCmd = sTempCmd + "*"
        
        self._txtFullCommand.Text = sTempCmd
            
    def ExitToolStripMenuItemClick(self, sender, e):
        self.Close()

    def TxtAddressTextChanged(self, sender, e):
        self.BuildCommand()

    def CbCommandSelectedIndexChanged(self, sender, e):
        self.BuildCommand()

    def TxtIoNumTextChanged(self, sender, e):
        self.BuildCommand()

    def TxtValueTextChanged(self, sender, e):
        self.BuildCommand()

    def CmdSendClick(self, sender, e):
        #Disable the Send button
        self._cmdSend.Enabled = False
        
        #Open a COM port and write the commad
        with IO.Ports.SerialPort("COM1") as serialPort:
            serialPort.BaudRate = 19200
            serialPort.DataBits = 8
            serialPort.Parity = System.IO.Ports.Parity.Even
            serialPort.Open()
            #Send PiXtend eIO Protocol message to the device
            serialPort.Write(self._txtFullCommand.Text)
            #wait for response
            time.sleep(0.5)
            #Read from the buffer unter until char "*" is found
            sData = serialPort.ReadTo("*")
            #The * char is removed, so we add it again for the gui
            sData = sData + "*"
            #Show response on gui
            self._txtResponse.Text = sData
            #Close the serial port
            serialPort.Close()
        #Enable the Send button again
        self._cmdSend.Enabled = True

    def MainFormShown(self, sender, e):
        self.BuildCommand()